CommonParamsHelper Class Reference

Utility class for dealing with the contents of CommonParams. More...

`#include <CommonParamsHelper.h>`

## Public Member Functions

| CommonParamsHelper ()
| ~CommonParamsHelper ()
void | readIdealAndSetOutput (const CommonParams &params, const DataType &output)
| Read input ideal and support specified kind of output.
void | readIdealAndSetPolyOutput (const CommonParams &params)
| Read input and support polynomial output.
void | readIdealAndSetIdealOutput (const CommonParams &params)
| Read input and support ideal output.
void | setIdealAndIdealOutput (const CommonParams &params, const BigIdeal &input, BigTermConsumer &output)
| Use given ideal and support ideal output.
void | setIdealAndPolyOutput (const CommonParams &params, const BigIdeal &input, CoefBigTermConsumer &output)
| Use given ideal and support polynomial output.
const VarNames & | getNames ()
Ideal & | getIdeal ()
const Ideal & | getIdeal () const
unique_ptr< Ideal > | takeIdeal ()
bool | hasIdeal () const
TermTranslator & | getTranslator ()
const TermTranslator & | getTranslator () const
unique_ptr< TermTranslator > | takeTranslator ()
BigTermConsumer & | getIdealConsumer ()
unique_ptr< TermConsumer > | makeTranslatedIdealConsumer (bool split=false)
CoefBigTermConsumer & | getPolyConsumer ()
unique_ptr< CoefTermConsumer > | makeTranslatedPolyConsumer ()
unique_ptr< CoefTermConsumer > | makeToUnivariatePolyConsumer ()
void | addPurePowersAtInfinity ()

## Private Member Functions

| CommonParamsHelper (const CommonParamsHelper &)
CommonParamsHelper & | operator= (const CommonParamsHelper &)
void | readIdeal (const CommonParams &params, Scanner &in)
void | setIdeal (const CommonParams &params, const BigIdeal &ideal)

## Private Attributes

unique_ptr< Ideal > | _ideal
unique_ptr< TermTranslator > | _translator
BigTermConsumer * | _idealConsumer
unique_ptr< BigTermConsumer > | _idealConsumerDeleter
CoefBigTermConsumer * | _polyConsumer
unique_ptr< CoefBigTermConsumer > | _polyConsumerDeleter
bool | _produceCanonicalOutput

## Detailed Description

Utility class for dealing with the contents of CommonParams.

Throws an appropriate exception if given invalid data.

Definition at line 38 of file CommonParamsHelper.h.

## Constructor & Destructor Documentation

## CommonParamsHelper() [1/2]

CommonParamsHelper::CommonParamsHelper | ( |  | ) |

Definition at line 43 of file CommonParamsHelper.cpp.

## ~CommonParamsHelper()

CommonParamsHelper::~CommonParamsHelper | ( |  | ) |

Definition at line 49 of file CommonParamsHelper.cpp.

## CommonParamsHelper() [2/2]

CommonParamsHelper::CommonParamsHelper | ( | const CommonParamsHelper & |  | ) |

private

## Member Function Documentation

## addPurePowersAtInfinity()

void CommonParamsHelper::addPurePowersAtInfinity | ( |  | ) |

Definition at line 164 of file CommonParamsHelper.cpp.

## getIdeal() [1/2]

Ideal & CommonParamsHelper::getIdeal | ( |  | ) |

inline

Definition at line 65 of file CommonParamsHelper.h.

## getIdeal() [2/2]

const Ideal & CommonParamsHelper::getIdeal | ( |  | ) | const

inline

Definition at line 66 of file CommonParamsHelper.h.

## getIdealConsumer()

BigTermConsumer & CommonParamsHelper::getIdealConsumer | ( |  | ) |

inline

Definition at line 74 of file CommonParamsHelper.h.

## getNames()

const VarNames & CommonParamsHelper::getNames | ( |  | ) |

inline

Definition at line 63 of file CommonParamsHelper.h.

## getPolyConsumer()

CoefBigTermConsumer & CommonParamsHelper::getPolyConsumer | ( |  | ) |

inline

Definition at line 78 of file CommonParamsHelper.h.

## getTranslator() [1/2]

TermTranslator & CommonParamsHelper::getTranslator | ( |  | ) |

inline

Definition at line 70 of file CommonParamsHelper.h.

## getTranslator() [2/2]

const TermTranslator & CommonParamsHelper::getTranslator | ( |  | ) | const

inline

Definition at line 71 of file CommonParamsHelper.h.

## hasIdeal()

bool CommonParamsHelper::hasIdeal | ( |  | ) | const

inline

Definition at line 68 of file CommonParamsHelper.h.

## makeToUnivariatePolyConsumer()

unique_ptr< CoefTermConsumer > CommonParamsHelper::makeToUnivariatePolyConsumer | ( |  | ) |

Definition at line 159 of file CommonParamsHelper.cpp.

## makeTranslatedIdealConsumer()

unique_ptr< TermConsumer > CommonParamsHelper::makeTranslatedIdealConsumer | ( | bool | split = false | ) |

Definition at line 128 of file CommonParamsHelper.cpp.

## makeTranslatedPolyConsumer()

unique_ptr< CoefTermConsumer > CommonParamsHelper::makeTranslatedPolyConsumer | ( |  | ) |

Definition at line 149 of file CommonParamsHelper.cpp.

## operator=()

CommonParamsHelper & CommonParamsHelper::operator= | ( | const CommonParamsHelper & |  | ) |

private

## readIdeal()

void CommonParamsHelper::readIdeal | ( | const CommonParams & | params,
|  | Scanner & | in )

private

Definition at line 168 of file CommonParamsHelper.cpp.

## readIdealAndSetIdealOutput()

void CommonParamsHelper::readIdealAndSetIdealOutput | ( | const CommonParams & | params | ) |

Read input and support ideal output.

Definition at line 97 of file CommonParamsHelper.cpp.

## readIdealAndSetOutput()

void CommonParamsHelper::readIdealAndSetOutput | ( | const CommonParams & | params,
|  | const DataType & | output )

Read input ideal and support specified kind of output.

Definition at line 54 of file CommonParamsHelper.cpp.

## readIdealAndSetPolyOutput()

void CommonParamsHelper::readIdealAndSetPolyOutput | ( | const CommonParams & | params | ) |

Read input and support polynomial output.

Definition at line 85 of file CommonParamsHelper.cpp.

## setIdeal()

void CommonParamsHelper::setIdeal | ( | const CommonParams & | params,
|  | const BigIdeal & | ideal )

private

Definition at line 176 of file CommonParamsHelper.cpp.

## setIdealAndIdealOutput()

void CommonParamsHelper::setIdealAndIdealOutput | ( | const CommonParams & | params,
|  | const BigIdeal & | input,
|  | BigTermConsumer & | output )

Use given ideal and support ideal output.

Definition at line 110 of file CommonParamsHelper.cpp.

## setIdealAndPolyOutput()

void CommonParamsHelper::setIdealAndPolyOutput | ( | const CommonParams & | params,
|  | const BigIdeal & | input,
|  | CoefBigTermConsumer & | output )

Use given ideal and support polynomial output.

Definition at line 119 of file CommonParamsHelper.cpp.

## takeIdeal()

unique_ptr< Ideal > CommonParamsHelper::takeIdeal | ( |  | ) |

inline

Definition at line 67 of file CommonParamsHelper.h.

## takeTranslator()

unique_ptr< TermTranslator > CommonParamsHelper::takeTranslator | ( |  | ) |

inline

Definition at line 72 of file CommonParamsHelper.h.

## Member Data Documentation

## _ideal

unique_ptr<Ideal> CommonParamsHelper::_ideal

private

Definition at line 92 of file CommonParamsHelper.h.

## _idealConsumer

BigTermConsumer* CommonParamsHelper::_idealConsumer

private

Definition at line 95 of file CommonParamsHelper.h.

## _idealConsumerDeleter

unique_ptr<BigTermConsumer> CommonParamsHelper::_idealConsumerDeleter

private

Definition at line 96 of file CommonParamsHelper.h.

## _polyConsumer

CoefBigTermConsumer* CommonParamsHelper::_polyConsumer

private

Definition at line 98 of file CommonParamsHelper.h.

## _polyConsumerDeleter

unique_ptr<CoefBigTermConsumer> CommonParamsHelper::_polyConsumerDeleter

private

Definition at line 99 of file CommonParamsHelper.h.

## _produceCanonicalOutput

bool CommonParamsHelper::_produceCanonicalOutput

private

Definition at line 101 of file CommonParamsHelper.h.

## _translator

unique_ptr<TermTranslator> CommonParamsHelper::_translator

private

Definition at line 93 of file CommonParamsHelper.h.

The documentation for this class was generated from the following files:

- src/CommonParamsHelper.h
- src/CommonParamsHelper.cpp